=== debian/control ===
Source: ycmd
Section: devel
Priority: optional
Maintainer: Onur Aslan <onur@onur.im>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: debhelper-compat (= 11),
 cmake,
 dh-python,
 python3-dev,
 googletest,
 libclang-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libgtest-dev
Standards-Version: 4.2.1
Homepage: https://github.com/Valloric/ycmd
Vcs-Git: https://salsa.debian.org/debian/ycmd.git
Vcs-Browser: https://salsa.debian.org/debian/ycmd

Package: ycmd
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python3:Depends},
 python3-bottle,
 python3-future,
 python3-frozendict,
 python3-jedi (>= 0.12.0),
 python3-requests (>= 2.2.1),
 python3-waitress
Recommends: vim-youcompleteme,
 node-typescript,
 libclang-common-${misc:Clang-Ver}-dev
Provides: ycmd-core-version (= ${misc:Core-Ver})
Description: code-completion & comprehension server
 ycmd is a server that provides APIs for code-completion and other
 code-comprehension use-cases like semantic GoTo commands (and others). For
 certain filetypes, ycmd can also provide diagnostic errors and warnings.
