=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, date=%Y%m%d, pretty=0+%cd+git%h" \
https://github.com/Valloric/ycmd \
HEAD debian uupdate
