=== debian/changelog ===
ycmd (0+20191222+git2771f6f+ds-1build5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:58:54 +0100

ycmd (0+20191222+git2771f6f+ds-1build4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:26:34 +0100

ycmd (0+20191222+git2771f6f+ds-1build3) focal; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 19:10:22 +0000

ycmd (0+20191222+git2771f6f+ds-1build2) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 22:04:53 +0000

ycmd (0+20191222+git2771f6f+ds-1build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:44:52 +0000
