=== debian/control ===
--- 
+++ 
@@ -1,20 +1,22 @@
 Source: ycmd
 Section: devel
 Priority: optional
-Maintainer: Onur Aslan <onur@onur.im>
-Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Build-Depends: debhelper-compat (= 11),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: David Kalnischkies <donkult@debian.org>
+Build-Depends: debhelper-compat (= 12),
  cmake,
  dh-python,
  python3-dev,
  googletest,
- libclang-dev,
+ libclang-9-dev,
  libboost-system-dev,
  libboost-filesystem-dev,
  libboost-regex-dev,
- libgtest-dev
-Standards-Version: 4.2.1
-Homepage: https://github.com/Valloric/ycmd
+ libgtest-dev,
+ pybind11-dev (>= 2.3.0)
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Homepage: https://ycm-core.github.io/ycmd/
 Vcs-Git: https://salsa.debian.org/debian/ycmd.git
 Vcs-Browser: https://salsa.debian.org/debian/ycmd
