=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: ycmd
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: David Kalnischkies <donkult@debian.org>
+Maintainer: David Kalnischkies <donkult@debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
  dh-python,
  python3-dev,
+ python3-regex,
  googletest,
- libclang-9-dev,
+ libclang-dev (>= 1:9.0),
  libboost-system-dev,
  libboost-filesystem-dev,
- libboost-regex-dev,
  libgtest-dev,
- pybind11-dev (>= 2.3.0)
-Standards-Version: 4.4.1
+ libwhereami-dev,
+ pybind11-dev (>= 2.3.0),
+ unicode-data (>= 13.0.0)
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://ycm-core.github.io/ycmd/
 Vcs-Git: https://salsa.debian.org/debian/ycmd.git
@@ -28,7 +29,7 @@
  python3-bottle,
  python3-future,
  python3-frozendict,
- python3-jedi (>= 0.12.0),
+ python3-jedi (>= 0.16.0),
  python3-requests (>= 2.2.1),
  python3-waitress
 Recommends: vim-youcompleteme,
